Index: /branches/ProgrammableProblem/HeuristicLab.Problems.Programmable/3.3/New/Scripts/MultiObjectiveProblemDefinitionScript.cs
===================================================================
--- /branches/ProgrammableProblem/HeuristicLab.Problems.Programmable/3.3/New/Scripts/MultiObjectiveProblemDefinitionScript.cs	(revision 11739)
+++ /branches/ProgrammableProblem/HeuristicLab.Problems.Programmable/3.3/New/Scripts/MultiObjectiveProblemDefinitionScript.cs	(revision 11739)
@@ -0,0 +1,126 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Optimization;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Problems.Programmable {
+  [Item("Multi-objective Problem Definition Script", "Script that defines the parameter vector and evaluates the solution for a programmable problem.")]
+  [StorableClass]
+  public class MultiObjectiveProblemDefinitionScript : ProblemDefinitionScript, IMultiObjectiveProblemDefinition, IStorableContent {
+    public string Filename { get; set; }
+
+    protected override string CodeTemplate {
+      get {
+        return @"using System;
+using System.Linq;
+using System.Collections.Generic;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Encodings.PermutationEncoding;
+using HeuristicLab.Optimization;
+using HeuristicLab.Problems.Programmable;
+
+public class CustomProblemDefinition : CompiledProblemDefinition, IMultiObjectiveProblemDefinition {
+  public bool[] Maximization { get { return new [] { false, false }; } }
+
+  public CustomProblemDefinition() {
+    // Define the solution encoding which can also consist of multiple vectors, examples below
+    // Encoding = new BinaryEncoding(""b"", length: 5);
+    // Encoding = new IntegerEncoding(""i"", lenght: 5, min: 2, max: 14, step: 4);
+    // Encoding = new RealEncoding(""r"", length: 5, min: -1.0, max: 1.0);
+    // Encoding = new PermutationEncoding(""P"", length: 5, type: PermutationTypes.Absolute);
+    // Encoding = new MultiEncoding()
+      // .AddBinaryVector(""b"", length: 5)
+      // .AddIntegerVector(""i"", length: 5, min: 2, max: 14, step: 4)
+      // .AddRealVector(""r"", length: 5, min: -1.0, max: 1.0)
+      // .AddPermutation(""P"", length: 5, type: PermutationTypes.Absolute)
+    ;
+  }
+
+  public override void Initialize() {
+    // when the definition is created here you can initialize variables in the variable store
+  }
+
+  public double[] Evaluate(IRandom random, Individual individual) {
+    var qualities = new [] { 0.0, 0.0 };
+    // use vars.yourVariable to access variables in the variable store i.e. yourVariable
+    // qualities = new [] { individual.RealVector(""r"").Sum(x => x * x), individual.RealVector(""r"").Sum(x => x * x * x) };
+    return qualities;
+  }
+
+  public void Analyze(Individual[] individuals, double[][] qualities, ResultCollection results) {
+    // write or update results given the range of vectors and resulting qualities
+    // use e.g. vars.yourVariable to access variables in the variable store i.e. yourVariable
+  }
+
+  public override IEnumerable<Individual> GetNeighbors(IRandom random, Individual individual) {
+    // Create new vectors, based on the given one that represent small changes
+    // This method is only called from move-based algorithms (LocalSearch, SimulatedAnnealing, etc.)
+    while (true) {
+      // this is not an infinite loop as only a finite amount of samples will be drawn
+      // it is possible to return a concrete amount of neighbors also
+      var neighbor = (Individual)individual.Clone();
+      //e.g. make a bit flip in a binary parameter
+      //var bIndex = random.Next(neighbor.BinaryVector(""b"").Length);
+      //neighbor.BinaryVector(""b"")[bIndex] = !neighbor.BinaryVector(""b"")[bIndex];
+      yield return neighbor;
+    }
+  }
+
+  // implement further classes and methods
+}";
+      }
+    }
+
+    [StorableConstructor]
+    protected MultiObjectiveProblemDefinitionScript(bool deserializing) : base(deserializing) { }
+    protected MultiObjectiveProblemDefinitionScript(MultiObjectiveProblemDefinitionScript original, Cloner cloner)
+      : base(original, cloner) { }
+
+    public MultiObjectiveProblemDefinitionScript() {
+      Code = CodeTemplate;
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new MultiObjectiveProblemDefinitionScript(this, cloner);
+    }
+
+    public new IMultiObjectiveProblemDefinition CompiledProblemDefinition {
+      get { return (IMultiObjectiveProblemDefinition)base.CompiledProblemDefinition; }
+    }
+
+    bool[] IMultiObjectiveProblemDefinition.Maximization {
+      get { return CompiledProblemDefinition != null ? CompiledProblemDefinition.Maximization : new bool[0]; }
+    }
+
+    double[] IMultiObjectiveProblemDefinition.Evaluate(Individual individual, IRandom random) {
+      return CompiledProblemDefinition.Evaluate(individual, random);
+    }
+
+    void IMultiObjectiveProblemDefinition.Analyze(Individual[] individuals, double[][] qualities, ResultCollection results) {
+      CompiledProblemDefinition.Analyze(individuals, qualities, results);
+    }
+  }
+}
Index: /branches/ProgrammableProblem/HeuristicLab.Problems.Programmable/3.3/New/Scripts/ProblemDefinitionScript.cs
===================================================================
--- /branches/ProgrammableProblem/HeuristicLab.Problems.Programmable/3.3/New/Scripts/ProblemDefinitionScript.cs	(revision 11739)
+++ /branches/ProgrammableProblem/HeuristicLab.Problems.Programmable/3.3/New/Scripts/ProblemDefinitionScript.cs	(revision 11739)
@@ -0,0 +1,103 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Reflection;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Scripting;
+
+namespace HeuristicLab.Problems.Programmable {
+  [Item("ProblemDefinitionScript", "Script that defines the parameter vector and evaluates the solution for a programmable problem.")]
+  [StorableClass]
+  public abstract class ProblemDefinitionScript : Script, IProblemDefinition {
+    protected bool SuppressEvents { get; set; }
+
+    [Storable]
+    private VariableStore variableStore;
+    public VariableStore VariableStore {
+      get { return variableStore; }
+    }
+
+    [StorableConstructor]
+    protected ProblemDefinitionScript(bool deserializing) : base(deserializing) { }
+    protected ProblemDefinitionScript(ProblemDefinitionScript original, Cloner cloner)
+      : base(original, cloner) {
+      variableStore = cloner.Clone(original.variableStore);
+    }
+    protected ProblemDefinitionScript() :base(){
+      variableStore = new VariableStore();
+    }
+
+    IEncoding IProblemDefinition.Encoding {
+      get { return CompiledProblemDefinition != null ? CompiledProblemDefinition.Encoding : null; }
+    }
+    IEnumerable<Individual> IProblemDefinition.GetNeighbors(Individual individual, IRandom random) {
+      return CompiledProblemDefinition.GetNeighbors(individual, random);
+    }
+
+    private readonly object locker = new object();
+    private volatile IProblemDefinition compiledProblemDefinition;
+    protected IProblemDefinition CompiledProblemDefinition {
+      get {
+          lock (locker) {
+            if (compiledProblemDefinition == null) {
+              Compile();
+            }
+          }
+        return compiledProblemDefinition;
+      }
+      private set {
+        compiledProblemDefinition = value;
+        OnProblemDefinitionChanged();
+      }
+    }
+
+    public override Assembly Compile() {
+      var assembly = base.Compile();
+      var types = assembly.GetTypes();
+      try {
+        var inst = (CompiledProblemDefinition)Activator.CreateInstance(types.First(x => typeof(CompiledProblemDefinition).IsAssignableFrom(x)));
+        inst.vars = new Variables(VariableStore);
+        inst.Initialize();
+        CompiledProblemDefinition = inst;
+      }
+      catch {
+        compiledProblemDefinition = null;
+      }
+      return assembly;
+    }
+
+    protected override void OnCodeChanged() {
+      base.OnCodeChanged();
+      compiledProblemDefinition = null;
+    }
+
+    public event EventHandler ProblemDefinitionChanged;
+    protected virtual void OnProblemDefinitionChanged() {
+      var handler = ProblemDefinitionChanged;
+      if (handler != null) handler(this, EventArgs.Empty);
+    }
+  }
+}
Index: /branches/ProgrammableProblem/HeuristicLab.Problems.Programmable/3.3/New/Scripts/SingleObjectiveProblemDefinitionScript.cs
===================================================================
--- /branches/ProgrammableProblem/HeuristicLab.Problems.Programmable/3.3/New/Scripts/SingleObjectiveProblemDefinitionScript.cs	(revision 11739)
+++ /branches/ProgrammableProblem/HeuristicLab.Problems.Programmable/3.3/New/Scripts/SingleObjectiveProblemDefinitionScript.cs	(revision 11739)
@@ -0,0 +1,126 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Optimization;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Problems.Programmable {
+  [Item("Single-objective Problem Definition Script", "Script that defines the parameter vector and evaluates the solution for a programmable problem.")]
+  [StorableClass]
+  public sealed class SingleObjectiveProblemDefinitionScript : ProblemDefinitionScript, ISingleObjectiveProblemDefinition, IStorableContent {
+    public string Filename { get; set; }
+
+    protected override string CodeTemplate {
+      get {
+        return @"using System;
+using System.Linq;
+using System.Collections.Generic;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Encodings.PermutationEncoding;
+using HeuristicLab.Optimization;
+using HeuristicLab.Problems.Programmable;
+
+public class CustomProblemDefinition : CompiledProblemDefinition, ISingleObjectiveProblemDefinition {
+  public bool IsMaximizationProblem { get { return false; } }
+
+  public CustomProblemDefinition() {
+    // Define the solution encoding which can also consist of multiple vectors, examples below
+    // Encoding = new BinaryEncoding(""b"", length: 5);
+    // Encoding = new IntegerEncoding(""i"", lenght: 5, min: 2, max: 14, step: 4);
+    // Encoding = new RealEncoding(""r"", length: 5, min: -1.0, max: 1.0);
+    // Encoding = new PermutationEncoding(""P"", length: 5, type: PermutationTypes.Absolute);
+    // Encoding = new MultiEncoding()
+      // .AddBinaryVector(""b"", length: 5)
+      // .AddIntegerVector(""i"", length: 5, min: 2, max: 14, step: 4)
+      // .AddRealVector(""r"", length: 5, min: -1.0, max: 1.0)
+      // .AddPermutation(""P"", length: 5, type: PermutationTypes.Absolute)
+    ;
+  }
+
+  public override void Initialize() {
+    // when the definition is created here you can initialize variables in the variable store
+  }
+
+  public double Evaluate(IRandom random, Individual individual) {
+    var quality = 0.0;
+    // use vars.yourVariable to access variables in the variable store i.e. yourVariable
+    // quality = individual.RealVector(""r"").Sum(x => x * x);
+    return quality;
+  }
+
+  public void Analyze(Individual[] individuals, double[] qualities, ResultCollection results) {
+    // write or update results given the range of vectors and resulting qualities
+    // use e.g. vars.yourVariable to access variables in the variable store i.e. yourVariable
+  }
+
+  public override IEnumerable<Individual> GetNeighbors(IRandom random, Individual individual) {
+    // Create new vectors, based on the given one that represent small changes
+    // This method is only called from move-based algorithms (LocalSearch, SimulatedAnnealing, etc.)
+    while (true) {
+      // this is not an infinite loop as only a finite amount of samples will be drawn
+      // it is possible to return a concrete amount of neighbors also
+      var neighbor = (Individual)individual.Clone();
+      //e.g. make a bit flip in a binary parameter
+      //var bIndex = random.Next(neighbor.BinaryVector(""b"").Length);
+      //neighbor.BinaryVector(""b"")[bIndex] = !neighbor.BinaryVector(""b"")[bIndex];
+      yield return neighbor;
+    }
+  }
+
+  // implement further classes and methods
+}";
+      }
+    }
+
+    [StorableConstructor]
+    private SingleObjectiveProblemDefinitionScript(bool deserializing) : base(deserializing) { }
+    private SingleObjectiveProblemDefinitionScript(SingleObjectiveProblemDefinitionScript original, Cloner cloner) : base(original, cloner) { }
+    public SingleObjectiveProblemDefinitionScript() :base(){
+      Code = CodeTemplate;
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new SingleObjectiveProblemDefinitionScript(this, cloner);
+    }
+
+    public new ISingleObjectiveProblemDefinition CompiledProblemDefinition {
+      get { return (ISingleObjectiveProblemDefinition)base.CompiledProblemDefinition; }
+    }
+
+    bool ISingleObjectiveProblemDefinition.Maximization {
+      get { return CompiledProblemDefinition != null && CompiledProblemDefinition.Maximization; }
+    }
+
+    double ISingleObjectiveProblemDefinition.Evaluate(Individual individual, IRandom random) {
+      return CompiledProblemDefinition.Evaluate(individual, random);
+    }
+
+    void ISingleObjectiveProblemDefinition.Analyze(Individual[] individuals, double[] qualities, ResultCollection results) {
+      CompiledProblemDefinition.Analyze(individuals, qualities, results);
+    }
+  }
+}
Index: /branches/ProgrammableProblem/HeuristicLab.Problems.Programmable/3.3/New/SingleObjectiveProgrammableProblem.cs
===================================================================
--- /branches/ProgrammableProblem/HeuristicLab.Problems.Programmable/3.3/New/SingleObjectiveProgrammableProblem.cs	(revision 11739)
+++ /branches/ProgrammableProblem/HeuristicLab.Problems.Programmable/3.3/New/SingleObjectiveProgrammableProblem.cs	(revision 11739)
@@ -0,0 +1,75 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Linq;
+using HeuristicLab.Analysis;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Optimization;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Problems.Programmable {
+  [StorableClass]
+  public abstract class SingleObjectiveProgrammableProblem<TEncoding> : ProgrammableProblem<TEncoding, SingleObjectiveEvaluator>, ISingleObjectiveProblemDefinition
+  where TEncoding : class, IEncoding {
+    [StorableConstructor]
+    protected SingleObjectiveProgrammableProblem(bool deserializing) : base(deserializing) { }
+
+    protected SingleObjectiveProgrammableProblem(SingleObjectiveProgrammableProblem<TEncoding> original, Cloner cloner)
+      : base(original, cloner) {
+      ParameterizeOperators();
+    }
+
+    protected SingleObjectiveProgrammableProblem()
+      : base() {
+
+      Operators.Add(new BestScopeSolutionAnalyzer());
+      Operators.Add(new SingleObjectiveEvaluator());
+      Operators.Add(new SingleObjectiveAnalyzer());
+
+      ParameterizeOperators();
+    }
+
+    [StorableHook(HookType.AfterDeserialization)]
+    private void AfterDeserialization() {
+      ParameterizeOperators();
+    }
+
+    public abstract bool Maximization { get; }
+    public abstract double Evaluate(Individual individual, IRandom random);
+    public virtual void Analyze(Individual[] individuals, double[] qualities, ResultCollection results) { }
+
+
+    protected override void OnEvaluatorChanged() {
+      base.OnEvaluatorChanged();
+      ParameterizeOperators();
+    }
+
+    protected override void ParameterizeOperators() {
+      base.ParameterizeOperators();
+      foreach (var op in Operators.OfType<ISingleObjectiveEvaluationOperator>())
+        op.EvaluateFunc = Evaluate;
+      foreach (var op in Operators.OfType<ISingleObjectiveAnalysisOperator>())
+        op.AnalyzeAction = Analyze;
+    }
+
+  }
+}
Index: /branches/ProgrammableProblem/HeuristicLab.Problems.Programmable/3.3/New/SingleObjectiveScriptableProblem.cs
===================================================================
--- /branches/ProgrammableProblem/HeuristicLab.Problems.Programmable/3.3/New/SingleObjectiveScriptableProblem.cs	(revision 11739)
+++ /branches/ProgrammableProblem/HeuristicLab.Problems.Programmable/3.3/New/SingleObjectiveScriptableProblem.cs	(revision 11739)
@@ -0,0 +1,90 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Collections.Generic;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Optimization;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Problems.Programmable.Problems {
+  [Item("Scriptable Problem (single-objective)", "Represents a single-objective problem that can be scripted.")]
+  [Creatable("1 Test")]
+  [StorableClass]
+  public sealed class SingleObjectiveScriptableProblem : SingleObjectiveProgrammableProblem<IEncoding> {
+
+    private FixedValueParameter<SingleObjectiveProblemDefinitionScript> SingleObjectiveProblemScriptParameter {
+      get { return (FixedValueParameter<SingleObjectiveProblemDefinitionScript>)Parameters["ProblemScript"]; }
+    }
+
+    private SingleObjectiveProblemDefinitionScript ProblemScript {
+      get { return SingleObjectiveProblemScriptParameter.Value; }
+    }
+
+    private ISingleObjectiveProblemDefinition ProblemDefinition {
+      get { return SingleObjectiveProblemScriptParameter.Value; }
+    }
+
+    private SingleObjectiveScriptableProblem(SingleObjectiveScriptableProblem original, Cloner cloner)
+      : base(original, cloner) {
+      RegisterEvents();
+    }
+    public override IDeepCloneable Clone(Cloner cloner) { return new SingleObjectiveScriptableProblem(this, cloner); }
+
+
+    [StorableConstructor]
+    private SingleObjectiveScriptableProblem(bool deserializing) : base(deserializing) { }
+
+    public SingleObjectiveScriptableProblem()
+      : base() {
+      Parameters.Add(new FixedValueParameter<SingleObjectiveProblemDefinitionScript>("ProblemScript", "Defines the problem.", new SingleObjectiveProblemDefinitionScript() { Name = Name }));
+      RegisterEvents();
+    }
+
+    [StorableHook(HookType.AfterDeserialization)]
+    private void AfterDeserialization() {
+      RegisterEvents();
+    }
+
+    private void RegisterEvents() {
+      ProblemScript.ProblemDefinitionChanged += (o, e) => OnProblemDefinitionChanged();
+    }
+
+    private void OnProblemDefinitionChanged() {
+    }
+
+    public override bool Maximization {
+      get { return ProblemDefinition.Maximization; }
+    }
+
+    public override double Evaluate(Individual individual, IRandom random) {
+      return ProblemDefinition.Evaluate(individual, random);
+    }
+
+    public override void Analyze(Individual[] individuals, double[] qualities, ResultCollection results) {
+      ProblemDefinition.Analyze(individuals, qualities, results);
+    }
+    public override IEnumerable<Individual> GetNeighbors(Individual individual, IRandom random) {
+      return ProblemDefinition.GetNeighbors(individual, random);
+    }
+  }
+}
Index: /branches/ProgrammableProblem/HeuristicLab.Problems.Programmable/3.3/OLD_MultiObjectiveProgrammableProblem.cs
===================================================================
--- /branches/ProgrammableProblem/HeuristicLab.Problems.Programmable/3.3/OLD_MultiObjectiveProgrammableProblem.cs	(revision 11739)
+++ /branches/ProgrammableProblem/HeuristicLab.Problems.Programmable/3.3/OLD_MultiObjectiveProgrammableProblem.cs	(revision 11739)
@@ -0,0 +1,168 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Drawing;
+using System.Linq;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Optimization;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Problems.Programmable {
+  [Item("Programmable Problem (multi-objective)", "Represents a multi-objective problem that can be programmed.")]
+  [Creatable("Problems")]
+  [StorableClass]
+  public class OLD_MultiObjectiveProgrammableProblem : MultiObjectiveHeuristicOptimizationProblem<MultiObjectiveEvaluator, ISolutionCreator>, IParameterizedNamedItem, IStorableContent {
+    public string Filename { get; set; }
+
+    public static new Image StaticItemImage {
+      get { return Common.Resources.VSImageLibrary.Script; }
+    }
+
+    public new ParameterCollection Parameters {
+      get { return base.Parameters; }
+    }
+    IKeyedItemCollection<string, IParameter> IParameterizedItem.Parameters {
+      get { return Parameters; }
+    }
+
+    public IValueParameter<IMultiObjectiveProblemDefinition> ProblemDefinitionParameter {
+      get { return (IValueParameter<IMultiObjectiveProblemDefinition>)Parameters["ProblemDefinition"]; }
+    }
+
+    protected IValueParameter<IEncoding> EncodingParameter {
+      get { return (IValueParameter<IEncoding>)Parameters["Encoding"]; }
+    }
+
+    public IMultiObjectiveProblemDefinition ProblemDefinition {
+      get { return ProblemDefinitionParameter.Value; }
+      set { ProblemDefinitionParameter.Value = value; }
+    }
+
+    [Storable]
+    protected List<IParameter> DynamicEncodingParameters;
+
+    [StorableConstructor]
+    protected OLD_MultiObjectiveProgrammableProblem(bool deserializing) : base(deserializing) { }
+    protected OLD_MultiObjectiveProgrammableProblem(OLD_MultiObjectiveProgrammableProblem original, Cloner cloner)
+      : base(original, cloner) {
+      DynamicEncodingParameters = original.DynamicEncodingParameters.Select(cloner.Clone).ToList();
+      RegisterEventHandlers();
+    }
+    public OLD_MultiObjectiveProgrammableProblem()
+      : base(new MultiObjectiveEvaluator(), new MultiEncodingCreator()) {
+      Parameters.Add(new ValueParameter<IMultiObjectiveProblemDefinition>("ProblemDefinition", "Defines the problem.", new MultiObjectiveProblemDefinitionScript() { Name = Name }));
+      Parameters.Add(new ValueParameter<IEncoding>("Encoding", "Describes which parameters exist, what they're called, what type they are and their bounds if any."));
+
+      DynamicEncodingParameters = new List<IParameter>();
+
+      Operators.Add(new MultiObjectiveAnalyzer());
+      Operators.Add(Evaluator);
+
+      RegisterEventHandlers();
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new OLD_MultiObjectiveProgrammableProblem(this, cloner);
+    }
+
+    [StorableHook(HookType.AfterDeserialization)]
+    // ReSharper disable UnusedMember.Local
+    private void AfterDeserialization() {
+      RegisterEventHandlers();
+    }
+    // ReSharper restore UnusedMember.Local
+
+    private void RegisterEventHandlers() {
+      ProblemDefinitionParameter.ValueChanged += ProblemDefinitionParameterOnValueChanged;
+      RegisterHostInstanceChanges();
+    }
+
+    private void ProblemDefinitionParameterOnValueChanged(object sender, EventArgs eventArgs) {
+      RegisterHostInstanceChanges();
+      Parameterize();
+    }
+
+    private void RegisterHostInstanceChanges() {
+      //ProblemDefinitionParameter.Value.ProblemDefinitionChanged += ProblemDefinitionChanged;
+      ProblemDefinitionParameter.Value.NameChanged += ProblemDefinitionHostOnNameChanged;
+    }
+
+    private void ProblemDefinitionHostOnNameChanged(object sender, EventArgs eventArgs) {
+      if (sender != ProblemDefinitionParameter.Value) return;
+      Name = ProblemDefinitionParameter.Value.Name;
+    }
+
+    protected override void OnNameChanged() {
+      base.OnNameChanged();
+      ProblemDefinitionParameter.Value.Name = Name;
+    }
+
+    protected override void OnEvaluatorChanged() {
+      base.OnEvaluatorChanged();
+      Parameterize();
+    }
+
+    protected virtual void ProblemDefinitionChanged(object sender, EventArgs eventArgs) {
+      Parameterize();
+    }
+
+    protected virtual void Parameterize() {
+      var definition = ProblemDefinitionParameter.Value;
+      if (definition == null) return;
+
+      IEncoding encoding = definition.Encoding;
+      EncodingParameter.Value = encoding;
+      Maximization = new BoolArray(definition.Maximization);
+
+      Evaluator.EncodingParameter.ActualName = EncodingParameter.Name;
+      //Evaluator.ProblemDefinitionParameter.ActualName = ProblemDefinitionParameter.Name;
+      //foreach (var evalOp in Operators.OfType<IMultiObjectiveProgrammableProblemEvaluator>()) {
+      //  evalOp.EncodingParameter.ActualName = EncodingParameter.Name;
+      //  evalOp.ProblemDefinitionParameter.ActualName = ProblemDefinitionParameter.Name;
+      //}
+      //foreach (var analyzeOp in Operators.OfType<IMultiObjectiveProgrammableProblemAnalyzer>()) {
+      //  analyzeOp.EncodingParameter.ActualName = EncodingParameter.Name;
+      //  analyzeOp.ProblemDefinitionParameter.ActualName = ProblemDefinitionParameter.Name;
+      //  analyzeOp.QualitiesParameter.ActualName = Evaluator.QualitiesParameter.ActualName;
+      //}
+
+      SolutionCreator = encoding.SolutionCreator;
+
+      foreach (var param in DynamicEncodingParameters)
+        if (Parameters.Contains(param)) Parameters.Remove(param);
+      DynamicEncodingParameters.Clear();
+
+      DynamicEncodingParameters.AddRange(encoding.Parameters);
+
+
+      foreach (var param in DynamicEncodingParameters) {
+        param.Hidden = true;
+        Parameters.Add(param);
+      }
+
+    }
+  }
+}
